/*

					Logic Scope AVR

				   Support Functions

			Copyrights 2009,  Yoshi Hiroshi

				DEVICE:ATtiny2313, TCN75A
				FUNCTION: I2Cڑ̉xv


*/


#include <avr/io.h>
#include <avr/interrupt.h>
#include "uart.h"
#include "usitwi2313.h"

struct TWIreq	tcn75aTWIreq;

ISR(TIMER1_COMPA_vect)
{
	unsigned char digit[4];
	PORTD &= ~0x20;			// PD5:OFF
	PORTD |= 0x40;			// PD6:ON
	PORTB |= 0x01;			// LED:ON
	PORTD |= 0x20;			// PD5:ON
	doTWIrequest(&tcn75aTWIreq);
	if(tcn75aTWIreq.actualLength == 2)
	{
		digit[1] = tcn75aTWIreq.recieveBuffer[0] / 10;
		digit[2] = tcn75aTWIreq.recieveBuffer[0] - digit[1] * 10;
		digit[3] = tcn75aTWIreq.recieveBuffer[1] * 10 / 256;
		sendUART(digit[1] + 0x30);
		sendUART(digit[2] + 0x30);
		sendUART('.');
		sendUART(digit[3] + 0x30);
		sendUART(0x0D);
	}
	PORTD &= ~0x40;			// PD6:OFF
	PORTB &= 0xFE;			// LED:OFF
}

//----------------------------------------------
void initTCN75A()
{
	tcn75aTWIreq.slaveAdrs = 0x4F;
	tcn75aTWIreq.commandLength = 2;
	tcn75aTWIreq.commandBuffer[0] = 0x01;	// Select register 1:Coniguration
	tcn75aTWIreq.commandBuffer[1] = 0b01100000;	// Select register 1:Coniguration
	tcn75aTWIreq.recieveLength = 0;
	doTWIrequest(&tcn75aTWIreq);

	tcn75aTWIreq.recieveLength = 2;
	tcn75aTWIreq.commandLength = 1;
	tcn75aTWIreq.commandBuffer[0] = 0x00;	// Select register 0:Temperature
}

//----------------------------------------------
void initApplication()
{
	CLKPR = _BV(CLKPCE);
	CLKPR = 0x00;						// Diveide by 1, so Clock = 8MHz
	long work = (F_CPU / 1000) * 500 / 256;

	TCCR1B |= _BV(WGM12);				// CTC mode
	TCCR1B |= _BV(CS12);				// devide by 256
	OCR1A  = work;  					// interrupt every 500ms
	TCNT1 = OCR1A - 1;
	TIMSK |= _BV(OCIE1A);

//===== for debug ==========//
	PORTB &= ~0x01;			//	LED port
	DDRB |= 0x03;			//	 as OUTPUT
	PORTD &= ~0x40;			//	Trigger PD6:OFF
	PORTD |= 0x20;			//			PD5:ON
	DDRD |= 0x60;			//	Synch Signal for IVXR[v
//==========================//
}

int main()
{
	initApplication();
	initTWI();
	initTCN75A();
	initUART();
	sei();
	while(1)
	{
	}
}
