/*

					Logic Scope AVR

				   Support Functions

			Copyrights 2009,  Yoshi Hiroshi

*/

#include <avr/io.h>
#define F_CPU	8000000
#include <util/delay.h>

struct TWIreq
{
	unsigned char slaveAdrs;			// 7bit address
	unsigned char commandLength;		//
	unsigned char commandBuffer[8];		//
	unsigned char recieveLength;		//
	unsigned char actualLength;
	unsigned char recieveBuffer[8];		//
} ;

unsigned char doTWIrequest(struct TWIreq* req);
void initTWI();

//===============================================
//
//		Definitions for Internal Use
//

//--- TWI value
#define TWI_REQUEST_WRITE		0
#define TWI_REQUEST_READ		1
#define TWI_RESPONCE_ACK		0
#define TWI_RESPONCE_NACK		1
//--- Inernal Value
#define DELAY_SHORT				2
#define DELAY_LONG				4
//--- Bit Assignment
#define TWI_SCL					7
#define TWI_SDA					5
//--- Register Assignment
#define TWI_SCL_PORT			PORTB
#define TWI_SCL_DDR				DDRB
#define TWI_SCL_PIN				PINB
#define TWI_SDA_PORT			PORTB
#define TWI_SDA_DDR				DDRB
#define TWI_DATA_REGISTER		USIDR

//--- MACRO Assignment
#define TWI_SCL_FREE			TWI_SCL_PORT |= _BV(TWI_SCL)
#define TWI_SCL_SET_LOW			TWI_SCL_PORT &= ~_BV(TWI_SCL)
#define TWI_SCL_CURR_VAL		(TWI_SCL_PIN  & _BV(TWI_SCL))
#define TWI_SCL_AS_INPUT		TWI_SCL_DDR &= ~_BV(TWI_SCL)
#define TWI_SCL_AS_OUTPUT		TWI_SCL_DDR |= _BV(TWI_SCL)
#define TWI_SDA_FREE			TWI_SDA_PORT |= _BV(TWI_SDA)
#define TWI_SDA_FREE_WITH_DR	TWI_SDA_PORT |= _BV(TWI_SDA); TWI_DATA_REGISTER=0xFF
#define TWI_SDA_FREE_ONLY_DR	USIDR=0xFF
#define TWI_SDA_SET_LOW			TWI_SDA_PORT &= ~_BV(TWI_SDA)
#define TWI_SDA_AS_INPUT		TWI_SDA_DDR &= ~_BV(TWI_SDA)
#define TWI_SDA_AS_OUTPUT		TWI_SDA_DDR |= _BV(TWI_SDA)

